'3AD Accelerometer Demo and Test Code (C) 2010 Rayslogic.com, LLC
'This code tests and calibrates the 3AD's MEMS 3-Axis accelerometer (Freescale MMA7455L)
'Raw readings are sent via Prop Plug to the computer.
'Use the Parallax Serial Terminal to see the raw data. 
'Ideally, the accelerometer should read x=0, y=0, z=+64 when 3AD is held flat.
'Note that a reading of 64 corresponds to 1 gee, the reading of earths gravity.
'But, the actual raw readings may be something like:  x=+15, y=-18, z=+54
'You probably want to record the flat values to use as a calibration offset.

CON        'Crystal Settings
  'Assing you're using a 5MHz crystal, otherwise you much change this section to match
  _clkmode = xtal1+pll16x
  _clkfreq = 80_000_000


OBJ      'I2C and Serial objects
  i2c: "PSB_I2CDriver"    'talks to accelerometer over i2c
  ser: "fullduplexserial"  'Sends reading over serial connection to computer


pub Test3AD|x,y,z,i          'Test the 3AD with PropPlug connection

  ser.start(31,30,0,9600)
  waitcnt(cnt+clkfreq*2)  'Wait a second so you can start up PST
    
  'Initialize the Accelerometer
  i2c.WriteAccelReg($16,%0101)

  repeat
    'Get and show readings
    x:=i2c.GetAccelX8
    y:=i2c.GetAccelY8
    z:=i2c.GetAccelZ8
    ser.tx(13)
    ser.str(string("X= "))
    ser.dec(x)
    ser.str(string("  Y= "))
    ser.dec(y)      
    ser.str(string("  Z= "))
    ser.dec(z)    

